@echo off

if not "%1" == "" goto ok1

:usage
echo Usage: txboot program
goto quit

:ok1

set TXCORELIB=..\compiler\t3x.cls
set TXBOOTLIB=..\Boot\boot.cls

if not %1 == -1 goto nots1

shift
REM ************************************************************
REM Using some stage-2 binaries in stage-1. Not sure if this is
REM a good idea, but it does speed up boostrapping significantly.
REM ************************************************************
if exist ..\compiler\txtrn1.exe goto TRNEXE
set TXTRN=..\Boot\txx ..\Boot\txtrn.tcode
goto TRNDONE
:TRNEXE
set TXTRN=..\compiler\txtrn1.exe
:TRNDONE
if exist ..\compiler\txld1.exe goto LDEXE
set TXLD=..\Boot\txx ..\compiler\txld.tcode
goto LDDONE
:LDEXE
set TXLD=..\compiler\txld1.exe
:LDDONE
if exist ..\compiler\txcgexe1.exe goto CGEXE
set TXCG=..\Boot\txx ..\compiler\txcgexe.tcode
goto CGDONE
:CGEXE
set TXCG=..\compiler\txcgexe1.exe
:CGDONE
set TXOPT=NA
set TXDPF=NA
set PRINT=echo
set N=%11
set O=%11.exe
goto endopts

:nots1
if not %1 == -2 goto nots2

shift
set TXTRN=..\compiler\txtrn1.exe
set TXLD=..\compiler\txld1.exe
set TXCG=..\compiler\txcgexe1.exe
set TXOPT=NA
set TXDPF=NA
set PRINT=REM
set N=%12
set O=%12.exe
goto endopts

:nots2
if not %1 == -3 goto nots3

shift
set TXTRN=..\compiler\txtrn2.exe
set TXLD=..\compiler\txld2.exe
set TXCG=..\compiler\txcgexe2.exe
set TXOPT=..\compiler\txopt2.exe
set TXDPF=..\compiler\txdpf2.exe
set PRINT=REM
set N=%13
set O=%1.exe
goto endopts

:nots3

set TXTRN=..\compiler\txtrn.exe
set TXLD=..\compiler\txld.exe
set TXCG=..\compiler\txcgexe.exe
set TXOPT=..\compiler\txopt.exe
set TXDPF=..\compiler\txdpf.exe
set PRINT=REM
set N=%1
set O=%1.exe

:endopts

if exist %1.t goto ok2

echo "cannot open: %1.t"
goto quit

:ok2

if exist CLASSDIR del CLASSDIR >NUL
if exist LIBDIR del LIBDIR >NUL

copy /b %TXCORELIB%+%TXBOOTLIB% %N%.tmp >NUL
%PRINT% TXTRN
%TXTRN% <%1.t >>%N%.tmp

%PRINT% TXLD
%TXLD% <%N%.tmp >%N%.tcode

if %TXOPT% == NA goto noopt
%PRINT% TXOPT
%TXOPT% <%N%.tcode >%N%.tmp
%PRINT% TXDPF
%TXDPF% <%N%.tmp >%N%.tcode
del %N%.tmp
:noopt

%PRINT% TXCG
%TXCG% <%N%.tcode >%O%

:quit
set TXTRN=
set TXLD=
set TXCG=
set TXOPT=
set TXDPF=
set TXBOOTLIB=
set N=
set O=
